basic_functions = require("lib.basic-functions")
hash = require("lib.hash")

local function create_new_bos_pw()
  basic_functions.clear_display()
  print("Enter a new Password for bos: ")
  local input = read("*")
  local pw_hash = hash.digestStr(input .. os.getComputerID())
  basic_functions.write_to_file("bos/files/bos-pw-hash.txt", pw_hash)
end

local function pw_prompt()
  write("Enter Password: ")
  pw_input = hash.digestStr(read("*") .. os.getComputerID())
end

local function timeout_check()
  sleep(10)
  timeout_event = true
end

local function pw_check(pw_input)
  local correct_pw = basic_functions.read_file_oneline("bos/files/bos-pw-hash.txt")
  return (pw_input == correct_pw)
end

local function main()
  --oldEvent = os.pullEvent
  --os.pullEvent = os.pullEventRaw
  if not (fs.exists("bos/files/bos-pw-hash.txt")) then
    create_new_bos_pw()
  end

  while (true) do
    basic_functions.clear_display()
    pw_input = nil
    timeout_event = false
    parallel.waitForAny(pw_prompt, timeout_check)
    local pw_check_passed = pw_check(pw_input)

    if (pw_check_passed) then
      basic_functions.clear_display()
      basic_functions.write_to_file("bos/files/system-lock-status.txt", false)
      print("Correct.")
      sleep(0.2)
      basic_functions.clear_display()
      return
    elseif timeout_event then
      basic_functions.clear_display()
      basic_functions.write_to_file("bos/files/system-lock-status.txt", true)
      print("Timeout...")
      sleep(1)
      return
    else
      basic_functions.clear_display()
      basic_functions.write_to_file("bos/files/system-lock-status.txt", true)
      print("Sorry that was not correct...")
      sleep(1)
      print("rebooting...")
      sleep(1)
      return
    end
  end
end

main()
